<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:output method="html" encoding="ISO-8859-1"/>
<xsl:template match="/">
  <HTML>
    <HEAD>
      <TITLE><xsl:value-of select="reportContext/@productFamily"/> Report</TITLE>
      <STYLE TYPE="text/css" MEDIA="all">@import url("hello2morrow.css");</STYLE>
    </HEAD>
    <BODY>
      <TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="0">
        <TR>
          <!-- Navigation column -->
          <TD WIDTH="200" BGCOLOR="#333333">
            <IMG SRC="spacer.gif" ALT="" WIDTH="200" HEIGHT="65" BORDER="0"/>
          </TD>
          <!-- Whitespace column -->
          <TD WIDTH="23" BGCOLOR="E3E4E5">
            <IMG SRC="spacer.gif" WIDTH="23" HEIGHT="1"/>
          </TD>
          <!-- Content column -->
          <TD WIDTH="100%" BGCOLOR="E3E4E5">
            <TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0">
              <TR>
                <TD WIDTH="7" BGCOLOR="E3E4E5">
                  <IMG SRC="spacer.gif" WIDTH="7" HEIGHT="1"/>
                </TD>
                <TD>
                  <IMG SRC="hello2morrow.gif" ALT="hello2morrow" WIDTH="227" HEIGHT="23" BORDER="0"/>
                </TD>
                <TD WIDTH="100%" ALIGN="right" BGCOLOR="E3E4E5">
                  <IMG SRC="header.gif" ALT="hello2morrow" WIDTH="543" HEIGHT="65" BORDER="0"/>
                </TD>
              </TR>
            </TABLE>
          </TD>
        </TR>
        <!-- Horizontal black line -->
        <TR>
          <TD COLSPAN="3" BGCOLOR="#000000">
            <IMG SRC="spacer.gif" ALT="" WIDTH="1" HEIGHT="1" BORDER="0"/>
          </TD>
        </TR>
        <TR>
          <!-- Navigation column -->
          <TD BGCOLOR="#A7A9AC" valign="top">
            <TABLE CELLSPACING="3" >
              <TR>
                <TD WIDTH="200" HEIGHT="20" BGCOLOR="#A7A9AC">
                  <IMG SRC="spacer.gif" ALT="" WIDTH="200" HEIGHT="20" BORDER="0"/>
                </TD>
              </TR>
              <TR>
                <TD><A HREF="#projectContext"><B><FONT SIZE="1" COLOR="#FFFFFF">System</FONT></B></A></TD>
              </TR>              
              <TR>
                <TD><A HREF="#projects"><B><FONT size="1" COLOR="#FFFFFF">Projects</FONT></B></A></TD>
              </TR>
              <TR>
                <TD><A HREF="#configurations"><B><FONT size="1" COLOR="#FFFFFF">Configurations</FONT></B></A></TD>
              </TR>
              <TR>
                <TD><A HREF="#workspaces"><B><FONT size="1" COLOR="#FFFFFF">Workspaces</FONT></B></A></TD>
              </TR>              
              <TR>
                <TD><A HREF="#violations"><B><FONT size="1" COLOR="#FFFFFF">Violations (<xsl:value-of select="reportContext/violations/@numberOf"/>)</FONT></B></A></TD>
              </TR>
              <TR>
                <TD><A HREF="#consistencyProblems"><B><FONT size="1" COLOR="#FFFFFF">Consistency Warnings (<xsl:value-of select="reportContext/consistencyProblems/@numberOf"/>)</FONT></B></A></TD>
              </TR>
              <xsl:for-each select="reportContext/consistencyProblems/categories">
                <TR>
                  <TD>
                    <IMG SRC="spacer.gif" ALT="" WIDTH="20" HEIGHT="1" BORDER="0"/>
                    <A HREF="#consistencyProblems{@name}"><B><FONT SIZE="0" COLOR="#FFFFFF"><xsl:value-of select="@name"/> (<xsl:value-of select="@numberOf"/>)</FONT></B></A>
                  </TD>
                </TR>
              </xsl:for-each>
              <TR>
                <TD><A HREF="#cycleGroups"><B><FONT size="1" COLOR="#FFFFFF">Cycle Groups (<xsl:value-of select="reportContext/cycleGroups/@numberOf"/>)</FONT></B></A></TD>
              </TR>
              <TR>
                <TD>
                  <A HREF="#warnings"><B><FONT SIZE="1" COLOR="#FFFFFF">Warnings (<xsl:value-of select="reportContext/warnings/@numberOf"/>)</FONT></B></A>
                </TD>
              </TR>
              <xsl:for-each select="reportContext/warnings/warningsByAttributeGroup">
                <TR>
                  <TD>
                    <IMG SRC="spacer.gif" ALT="" WIDTH="20" HEIGHT="1" BORDER="0"/>
                    <A HREF="#warnings{@attributeGroup}"><B><FONT SIZE="0" COLOR="#FFFFFF"><xsl:value-of select="@attributeGroup"/> (<xsl:value-of select="@numberOf"/>)</FONT></B></A>
                  </TD>
                </TR>
              </xsl:for-each>
              <TR>
                <TD><A HREF="#tasks"><B><FONT size="1" COLOR="#FFFFFF">Tasks (<xsl:value-of select="reportContext/tasks/@numberOf"/>)</FONT></B></A></TD>
              </TR>
              <TR>
                <IMG SRC="spacer.gif" ALT="" WIDTH="20" HEIGHT="1" BORDER="0"/>
                <TD><A HREF="#exclusions"><B><FONT SIZE="1" COLOR="#FFFFFF">Exclusions</FONT></B></A></TD>
              </TR>
              <xsl:for-each select="reportContext/exclusions">
                <TR>
                  <TD>
                    <IMG SRC="spacer.gif" ALT="" WIDTH="20" HEIGHT="1" BORDER="0"/>
                    <A HREF="#exclusions{@name}"><B><FONT SIZE="0" COLOR="#FFFFFF"><xsl:value-of select="@name"/> (<xsl:value-of select="@numberOf"/>)</FONT></B></A>
                  </TD>
                </TR>
              </xsl:for-each>
			  <TR>
                <TD><A HREF="#metric table"><B><FONT size="1" COLOR="#FFFFFF">Metrics</FONT></B></A></TD>
              </TR>
			  <xsl:for-each select="reportContext/metrics">
                <TR>
                  <TD>
                    <IMG SRC="spacer.gif" ALT="" WIDTH="20" HEIGHT="1" BORDER="0"/>
                    <A HREF="#{@name}"><B><FONT SIZE="0" COLOR="#FFFFFF"><xsl:value-of select="@name"/> (<xsl:value-of select="count(metric)"/>)</FONT></B></A>
                  </TD>
                </TR>
              </xsl:for-each>
            </TABLE>
          </TD>
          <!-- Whitespace column -->
          <TD WIDTH="23">
            <IMG SRC="spacer.gif" WIDTH="23" HEIGHT="1"/>
          </TD>
          <!-- Content column -->
          <TD WIDTH="100%">
            <TABLE WIDTH="100%" border="0">
              <TR>
                <TD WIDTH="1%" HEIGHT="80" VALIGN="center">
                  <IMAGE SRC="{reportContext/@productFamily}.gif" WIDTH="350"/>
                </TD>
              </TR>
              <TR>
                <TD>
                  <H1 ID="projectContext">System: <xsl:value-of select="reportContext/@name"/></H1>
                </TD>
              </TR>
              <TR>
                <TD>
                  <TABLE BORDER="0" CELLSAPCING="0" CELLPADDING="0" WIDTH="50%">
                    <xsl:for-each select="reportContext/general/attribute[@name!='Base Path']">
                      <B><xsl:value-of select="@name"/>: </B>
                      <xsl:value-of select="@value"/>
                      <BR/>
                    </xsl:for-each>
                  </TABLE>
                </TD>
              </TR>
              <TR>
                <TD>
					<br/>
                  <H2>System Metrics:</H2>
                </TD>
              </TR>			  
              <xsl:for-each select="reportContext/attributes/attributeCategory">
              <TR class="a"><TD><B><xsl:value-of select="@name"/></B></TD></TR>
              <TR>
                <TD>
                  <TABLE CLASS="techTable" WIDTH="50%">
                    <TR>
                      <TH width="450">Name</TH>
                      <TH width="250">Value</TH>
                    </TR>
                    <xsl:for-each select="attribute">
                      <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
                        <TD width="450">
                          <a href="#metric {@name}"> <xsl:value-of select="@name"/></a>
                        </TD>
                        <TD width="250">
                          <xsl:value-of select="@value"/>
                        </TD>
                      </TR> 
                    </xsl:for-each>
                  </TABLE>
                </TD>
              </TR>
             </xsl:for-each>
              
            </TABLE>
          </TD>
        </TR>
        <TR>
          <!-- Navigation column -->
          <TD WIDTH="130" bgcolor="#A7A9AC">
            <IMG SRC="spacer.gif" ALT="" WIDTH="130" HEIGHT="65" BORDER="0"/>
          </TD>
          <!-- Whitespace column -->
          <TD WIDTH="23">
            <IMG SRC="spacer.gif" WIDTH="23" HEIGHT="1"/>
          </TD>
          <!-- Content column -->
          <TD WIDTH="100%">
            <TABLE WIDTH="100%" border="0">
              <TR>
                <TD WIDTH="100%">
                  <xsl:apply-templates/>
                </TD>
              </TR>
            </TABLE>
          </TD>
        </TR>
      </TABLE>
    </BODY>
  </HTML>
</xsl:template>

<xsl:template match="reportContext">
  <BR/>
  <H2 id="projects">Projects <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
  
  <TABLE CLASS="techTable" WIDTH="50%">
    <xsl:for-each select="projects/project">
      <xsl:choose>
        <xsl:when test="position() = 1">
          <TR>
            <TH width="250">Project</TH>
            <TH width="550">Description</TH>
          </TR>
        </xsl:when>
      </xsl:choose>
      <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
        <TD>
          <xsl:value-of select="@name"/>
        </TD>
        <TD>
          <xsl:value-of select="@description"/>
        </TD>
      </TR>
    </xsl:for-each>
  </TABLE>
  
  <BR/>
  
  <H2 id="configurations">Configurations <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
  <TABLE CLASS="techTable" WIDTH="75%">
  <TR>
  <TH width="250">Project</TH>
  <TH width="200">Parse Source Files</TH>
  <TH width="200">Analyze Asymmetrical Cycles</TH>
  <TH width="200">Generate Cycle Warnings for Namespaces</TH>
  <TH width="200">Generate Cycle Warnings for Source Files</TH>
  </TR>
  <xsl:for-each select="configurations/configuration">
  <TR>
    <TD>
        <xsl:value-of select="@project"/>
    </TD>
    <TD>
        <xsl:value-of select="@parseSourceFiles"/>
    </TD>
    <TD>
        <xsl:value-of select="@asymetricAnalysis"/>
    </TD>
    <TD>
        <xsl:value-of select="@namespaceWarnings"/>
    </TD>
    <TD>
        <xsl:value-of select="@sourcefileWarnings"/>
    </TD>
    </TR>
  </xsl:for-each>
  </TABLE>
  
  <H2 id="workspaces">Workspaces <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
  
  Base Path is <xsl:value-of select="general/attribute[@name='Base Path']/@value"/>
  <BR/>
  
  <TABLE CLASS="techTable" WIDTH="75%">
    <xsl:for-each select="workspaces/workspace/workspacePath">
      <xsl:choose>
        <xsl:when test="position() = 1">
          <TR>
            <TH width="250">Project</TH>
            <TH width="250">Build Unit</TH>
            <TH width="300">Workspace path</TH>
            <TH width="500">Description</TH>
          </TR>
        </xsl:when>
      </xsl:choose>
      <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
        <TD>
          <xsl:value-of select="../@project"/>
        </TD>
        <TD>
          <xsl:value-of select="../@buildUnit"/>
        </TD>
        <TD>
          <xsl:value-of select="@path"/>
        </TD>
        <TD>
          <xsl:value-of select="@description"/>
        </TD>
      </TR>
    </xsl:for-each>
  </TABLE>
  
  <BR/>
  
  <H2 ID="violations">Violations (<xsl:value-of select="violations/@numberOfViolatingTypeRelations"/> type relations out of <xsl:value-of select="violations/@numberOfTypeRelations"/> / <xsl:value-of select="violations/@percentageOfViolatingTypeRelations"/>%) <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
  
  <TABLE CLASS="techTable" WIDTH="90%">
    <xsl:for-each select="violations/architectureViolations">
      <xsl:sort select="architectureViolation[1]/attribute[@name='From scope']/@value" order="ascending"/>
      <xsl:sort select="architectureViolation[1]/attribute[@name='To scope']/@value" order="ascending"/>
      <xsl:sort select="architectureViolation[1]/attribute[@name='From']/@value" order="ascending"/>
      <xsl:sort select="architectureViolation[1]/attribute[@name='To']/@value" order="ascending"/>
      <xsl:choose>
        <xsl:when test="position() = 1">
          <TR>
            <TH WIDTH="150">From Scope</TH>
            <TH WIDTH="150">From Element Type</TH>
            <TH>From</TH>
            <TH>To</TH>
            <TH WIDTH="150">To Element Type</TH>
            <TH WIDTH="150">To Scope</TH>
            <TH>Type relations</TH>
          </TR>
        </xsl:when>
      </xsl:choose>
      <xsl:for-each select="architectureViolation">
        <TR CLASS="b">
          <xsl:for-each select="attribute">
            <TD><b>
              <xsl:value-of select="@value"/>
            </b></TD>
          </xsl:for-each>
        </TR>
      </xsl:for-each>
  
      <!-- group by explanation -->
      <xsl:for-each select="typeRelation[not(attribute[@name='Explanation']/@value = preceding-sibling::typeRelation/attribute[@name='Explanation']/@value)]">
        <xsl:sort select="attribute[@name='Explanation']/@value" order="ascending"/>
        <TR>
          <TD></TD> 
          <TD></TD>
          <TD bgcolor="#FFBBCC" colspan="2"><xsl:value-of select="attribute[@name='Explanation']/@value"/></TD>
        </TR>
        <xsl:for-each select="../typeRelation[attribute[@name='Explanation']/@value = current()/attribute[@name='Explanation']/@value]">
          <xsl:sort select="attribute[@name='To']/@value" order="ascending"/>
          <xsl:sort select="attribute[@name='From']/@value" order="ascending"/>
          <xsl:choose>
            <xsl:when test="position() mod 2 = 1"><!-- white -->
              <TR CLASS="a">
                <TD/><TD/>
                <TD>
                  <xsl:value-of select="attribute[@name='From']/@value"/>
                </TD>
                <TD>
                  <xsl:value-of select="attribute[@name='To']/@value"/>
                </TD>
                <TD/><TD/><TD/>
              </TR>
            </xsl:when>
            <xsl:otherwise><!-- grey -->
              <TR>
                <TD/><TD/>
                <TD CLASS="b">
                  <xsl:value-of select="attribute[@name='From']/@value"/>
                </TD>
                <TD CLASS="b">
                  <xsl:value-of select="attribute[@name='To']/@value"/>
                </TD>
                <TD/><TD/><TD/>
              </TR>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </TABLE>
  <BR/>
  <BR/>
  
  <H2 ID="consistencyProblems">Architecture Consistency Warnings (<xsl:value-of select="consistencyProblems/@numberOf"/>) <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
  <xsl:for-each select="consistencyProblems/categories">
    <H3 ID="consistencyProblems{@name}"><xsl:value-of select="@name"/> problems (<xsl:value-of select="@numberOf"/>) 
      <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A>
    </H3>
   <xsl:if test="count(elementProblems) > 0">
      <TABLE>
        <TR><TD>Element problems:</TD></TR>
      </TABLE> 
      <TABLE CLASS="techTable" WIDTH="90%">
        <TR>
          <TH WIDTH="150">Scope</TH>
          <TH WIDTH="200">Element</TH>
          <TH WIDTH="400">Description</TH>
        </TR>
        <xsl:for-each select="elementProblems">
          <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
              <TD>
                <xsl:value-of select="@scope"/>
              </TD>
              <TD>
                <xsl:value-of select="@element"/>
              </TD>
              <TD>
                <xsl:value-of select="@description"/>
              </TD>
          </TR>
        </xsl:for-each>
      </TABLE>
   </xsl:if>
   <xsl:if test="count(dependencyProblems) > 0">
      <TABLE>
        <TR><TD>Dependency problems:</TD></TR>
      </TABLE>
      <TABLE CLASS="techTable" WIDTH="90%">
        <TR>
          <TH WIDTH="150">From scope</TH>
          <TH WIDTH="200">From</TH>
          <TH WIDTH="150">To scope</TH>
          <TH WIDTH="200">To</TH>
          <TH WIDTH="400">Description</TH>
        </TR>
        <xsl:for-each select="dependencyProblems">
          <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
              <TD>
                <xsl:value-of select="@fromScope"/>
              </TD>
              <TD>
                <xsl:value-of select="@fromElement"/>
              </TD>
              <TD>
                <xsl:value-of select="@toScope"/>
              </TD>
              <TD>
                <xsl:value-of select="@toElement"/>
              </TD>
              <TD>
                <xsl:value-of select="@description"/>
              </TD>
          </TR>
        </xsl:for-each>
      </TABLE>
    </xsl:if>
  </xsl:for-each>
  <BR/>

  <H2 ID="cycleGroups">Cycle Groups (<xsl:value-of select="cycleGroups/@numberOf"/>) <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
    <TABLE CLASS="techTable" WIDTH="90%">
      <TR>
        <TH WIDTH="200">Element scope</TH>
        <TH WIDTH="150">Parent element</TH>
        <TH>Description</TH>
      </TR>
      <xsl:for-each select="cycleGroups/cycleGroup">
        <xsl:sort select="@elementScope" order="ascending"/>
        <xsl:sort select="@parent" order="ascending"/>
        <TR CLASS="violation">
          <TD>
            <xsl:value-of select="@elementScope"/>
          </TD>
          <TD>
            <xsl:value-of select="@parent"/>
          </TD>
          <TD>
            <xsl:value-of select="@description"/>
          </TD>
        </TR>
        <xsl:for-each select="cyclePath">
          <xsl:sort select="@numberOfEfferentTypeRelationsInCycleGroup" data-type="number" order="descending"/>
          <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
            <TD>
            </TD>
            <TD>
              <xsl:value-of select="@parent"/>
            </TD>
            <TD>
              <xsl:value-of select="@description"/>
            </TD>
          </TR>
        </xsl:for-each>
      </xsl:for-each>
    </TABLE>
    <BR/>
  
  <H2 ID="warnings">Warnings (<xsl:value-of select="warnings/@numberOf"/>) <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
  <xsl:for-each select="warnings/warningsByAttributeGroup">
    <H3 ID="warnings{@attributeGroup}"><xsl:value-of select="@attributeGroup"/> warnings (<xsl:value-of select="@numberOf"/>) 
      <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A>
    </H3>
  
    <xsl:for-each select="warningsByAttribute">
      <B>Attribute name: </B>
      <xsl:value-of select="@attributeName"/> (<xsl:value-of select="@numberOf"/>)
      <BR/>
      <B>Attribute description: </B>
      <xsl:value-of select="@attributeDescription"/>
      <TABLE CLASS="techTable" WIDTH="90%">
        <TR>
	  <!-- Column headers -->
	  <xsl:for-each select="warning[1]/attribute">
	    <TH>
	      <xsl:choose>
		<xsl:when test="@name = 'Project'"><xsl:attribute name="WIDTH">200</xsl:attribute></xsl:when>
		<xsl:when test="@name = 'Element type'"><xsl:attribute name="WIDTH">150</xsl:attribute></xsl:when>
		<xsl:otherwise></xsl:otherwise></xsl:choose>	      
	      <xsl:value-of select="@name"/>
	    </TH>
	  </xsl:for-each>
        </TR>
        <xsl:for-each select="warning">
          <xsl:sort select="attribute[1]/@value" order="ascending"/>
          <xsl:sort select="attribute[2]/@value" order="ascending"/>
          <xsl:sort select="attribute[3]/@value" order="ascending"/>
        
          <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
            <xsl:for-each select="attribute">
              <TD>
                <xsl:value-of select="@value"/>
              </TD>
            </xsl:for-each>
          </TR>
        </xsl:for-each>
      </TABLE>
      <BR/>
    </xsl:for-each>
  </xsl:for-each>
  <BR/>
  
  <H2 ID="tasks">Tasks (<xsl:value-of select="tasks/@numberOf"/>) <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
  <TABLE CLASS="techTable" WIDTH="90%">
    <xsl:for-each select="tasks/task">
      <xsl:sort select="attribute[1]/@value" order="ascending"/>
      <xsl:sort select="attribute[2]/@value" order="ascending"/>
      <xsl:sort select="attribute[3]/@value" order="ascending"/>
      <xsl:choose>
        <xsl:when test="position() = 1">
          <TR>
            <TH WIDTH="200">Project</TH>
	    <TH>Build Unit</TH>
            <TH>Element type</TH>
            <TH>Element</TH>
            <TH>Description</TH>
            <TH>Priority</TH>
            <TH>Assigned to</TH>
          </TR>
        </xsl:when>
      </xsl:choose>
      <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
        <xsl:for-each select="attribute">
          <TD>
            <xsl:value-of select="@value"/>
          </TD>
        </xsl:for-each>
      </TR>
    </xsl:for-each>
  </TABLE>
  <BR/>
  
  <H2 ID="exclusions">Exclusions <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
  <xsl:for-each select="exclusions">
    <H3 ID="exclusions{@name}">Excluded <xsl:value-of select="@name"/> types (<xsl:value-of select="@numberOf"/>) 
      <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A>
    </H3>
		<xsl:choose>
          <xsl:when test="@numberOf > 0">		
		    <TABLE CLASS="techTable" WIDTH="90%">
		      <TR>
		        <TH WIDTH="200">Scope</TH>
		        <TH>Type</TH>
		      </TR>
		      <xsl:for-each select="excludedType">
		        <xsl:sort select="attribute[1]/@value" order="ascending"/>
		        <xsl:sort select="attribute[2]/@value" order="ascending"/>
		        <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
		          <xsl:for-each select="attribute">
		            <TD>
		              <xsl:value-of select="@value"/>
		            </TD>
		          </xsl:for-each>
		        </TR>
		      </xsl:for-each>
		    </TABLE>
	  	  </xsl:when>
		</xsl:choose>
  </xsl:for-each>

   <BR/>

  <H2 ID="metric table">Metrics <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>  
  <xsl:for-each select="metrics">
	<H3 ID="{@name}">
		<xsl:value-of select="@name"/><xsl:text> </xsl:text><A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A>
	</H3>
    <xsl:variable name="categoryName" select="@name"/>
    <xsl:for-each select="metric">
      <xsl:variable name="index" select="position()"/>
      <xsl:variable name="metricName" select="@name"/>
  
      <H4 id="metric {@name}">
        <u><xsl:value-of select="@name"/><xsl:text> </xsl:text><A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></u>
      </H4>
      <TABLE CLASS="techTable" WIDTH="50%">
	  <xsl:choose>
		<xsl:when test="string-length(@systemDescription) > 0">
	  	<TR>
			<TD WIDTH="700" align="left">
				<B>Metric description on System level:</B> <xsl:value-of select="@systemDescription"/>
			</TD>			
		</TR>
		</xsl:when>
		</xsl:choose>
		<xsl:choose>
		<xsl:when test="string-length(@projectDescription) > 0">
		<TR>
			<TD WIDTH="700" align="left">
				<B>Metric description on Project level:</B> <xsl:value-of select="@projectDescription"/>
			</TD>
		</TR>
		</xsl:when>
		</xsl:choose>
	  </TABLE>
	  <TABLE CLASS="techTable" WIDTH="40%">	  	
        <TR>
		  <TH width="250">System</TH>
          <TH width="50">Value</TH>
          <TH width="250">Project</TH>
          <TH width="50">Value</TH>
        </TR>
            <xsl:for-each select="../../projects/project">
            <xsl:choose>
            <xsl:when test="position() = 1 or string-length(attributeCategory[@name=$categoryName]/attribute[@name=$metricName]/@value) > 0">
	              <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
	                <xsl:choose>
				  	<xsl:when test="position() = 1">
					  <TD>
					  	<B><xsl:value-of select="../../@name"/></B>				    
	                  </TD>
	                  <TD align="right">
					  	<xsl:choose>
							<xsl:when test="string-length(../../attributes/attributeCategory[@name=$categoryName]/attribute[@name=$metricName]/@value) = 0">
								<B>N/A</B>
							</xsl:when>
							<xsl:otherwise>
	                    		<B><xsl:value-of select="../../attributes/attributeCategory[@name=$categoryName]/attribute[@name=$metricName]/@value"/></B>
							</xsl:otherwise>
						</xsl:choose>                    
	                  </TD>
					</xsl:when>
					<xsl:otherwise>
					  <TD>                    
	                  </TD>
	                  <TD>                    
	                  </TD>
					</xsl:otherwise>
				  	</xsl:choose>
						<xsl:choose>
							<xsl:when test="string-length(attributeCategory[@name=$categoryName]/attribute[@name=$metricName]/@value) = 0">
								<TD>                    
				                </TD>
				                <TD>                    
				                </TD>
							</xsl:when>
							<xsl:otherwise>
							<TD>
			                  <B><xsl:value-of select="@name"/></B>
			                </TD>
			                <TD align="right">
	                    		<B><xsl:value-of select="attributeCategory[@name=$categoryName]/attribute[@name=$metricName]/@value"/></B>
	                    	</TD>
							</xsl:otherwise>
						</xsl:choose>
	              </TR> 
              </xsl:when>
              </xsl:choose>
            </xsl:for-each>         
      </TABLE>	
	  <br/>  
	  <br/>
	  <br/>
    </xsl:for-each>
  </xsl:for-each>
   

</xsl:template>
</xsl:stylesheet>
<!-- Stylus Studio meta-information - (c) 2004-2009. Progress Software Corporation. All rights reserved.

<metaInformation>
	<scenarios>
		<scenario default="no" name="Scenario1" userelativepaths="yes" externalpreview="no" url="..\..\..\..\Desktop\report\Infoglue-report.xml" htmlbaseurl="" outputurl="" processortype="saxon8" useresolver="yes" profilemode="0" profiledepth=""
		          profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="no" validator="internal"
		          customvalidator="">
			<advancedProp name="sInitialMode" value=""/>
			<advancedProp name="bXsltOneIsOkay" value="true"/>
			<advancedProp name="bSchemaAware" value="true"/>
			<advancedProp name="bXml11" value="false"/>
			<advancedProp name="iValidation" value="0"/>
			<advancedProp name="bExtensions" value="true"/>
			<advancedProp name="iWhitespace" value="0"/>
			<advancedProp name="sInitialTemplate" value=""/>
			<advancedProp name="bTinyTree" value="true"/>
			<advancedProp name="bWarnings" value="true"/>
			<advancedProp name="bUseDTD" value="false"/>
			<advancedProp name="iErrorHandling" value="fatal"/>
		</scenario>
		<scenario default="yes" name="Scenario2" userelativepaths="yes" externalpreview="no" url="..\..\..\..\Desktop\xxx\blub [2011-03-31,14_20]-report.xml" htmlbaseurl="" outputurl="" processortype="saxon8" useresolver="yes" profilemode="0"
		          profiledepth="" profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="no"
		          validator="internal" customvalidator="">
			<advancedProp name="sInitialMode" value=""/>
			<advancedProp name="bXsltOneIsOkay" value="true"/>
			<advancedProp name="bSchemaAware" value="true"/>
			<advancedProp name="bXml11" value="false"/>
			<advancedProp name="iValidation" value="0"/>
			<advancedProp name="bExtensions" value="true"/>
			<advancedProp name="iWhitespace" value="0"/>
			<advancedProp name="sInitialTemplate" value=""/>
			<advancedProp name="bTinyTree" value="true"/>
			<advancedProp name="bWarnings" value="true"/>
			<advancedProp name="bUseDTD" value="false"/>
			<advancedProp name="iErrorHandling" value="fatal"/>
		</scenario>
	</scenarios>
	<MapperMetaTag>
		<MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no"/>
		<MapperBlockPosition></MapperBlockPosition>
		<TemplateContext></TemplateContext>
		<MapperFilter side="source"></MapperFilter>
	</MapperMetaTag>
</metaInformation>
-->